
Ruby - Bug #14150

ruby 2.5.0dev SEGV by rb_external_str_new_with_enc(NULL, 0, rb_usascii_encoding())

12/02/2017 02:15 AM - kubo (Takehiro Kubo)

Status: Closed   

Priority: Normal   

Assignee:    

Target version:    

ruby -v: ruby 2.5.0dev (2017-12-02 trunk 60975)

[x86_64-linux]

Backport: 2.3: UNKNOWN, 2.4: UNKNOWN

Description

rb_external_str_new_with_enc(NULL, 0, rb_usascii_encoding()) gets segmentation fault in ruby 2.5.0-preview1 and ruby 2.5.0dev.

It returns an empty string in released versions.

I made test code which calls following functions.

1. rb_str_new(NULL, 0);

2. rb_external_str_new(NULL, 0);

3. rb_locale_str_new(NULL, 0);

4. rb_usascii_str_new(NULL, 0);

5. rb_utf8_str_new(NULL, 0);

6. rb_enc_str_new(NULL, 0, rb_usascii_encoding());

7. rb_external_str_new_with_enc(NULL, 0, rb_usascii_encoding());

The first 6 worked fine but the last only failed.

Associated revisions

Revision a1692f7fdf62dc109886d9910b4dcca635dc2e25 - 12/02/2017 07:09 AM - nobu (Nobuyoshi Nakada)

string.c: fix rb_external_str_new_with_enc

string.c (rb_external_str_new_with_enc): do not search non-ascii

by NULL pointer.  [ruby-core:84055] [Bug #14150]

git-svn-id: svn+ssh://ci.ruby-lang.org/ruby/trunk@60979 b2dd03c8-39d4-4d8f-98ff-823fe69b080e

Revision a1692f7f - 12/02/2017 07:09 AM - nobu (Nobuyoshi Nakada)

string.c: fix rb_external_str_new_with_enc

string.c (rb_external_str_new_with_enc): do not search non-ascii

by NULL pointer.  [ruby-core:84055] [Bug #14150]

git-svn-id: svn+ssh://ci.ruby-lang.org/ruby/trunk@60979 b2dd03c8-39d4-4d8f-98ff-823fe69b080e

History

#1 - 12/02/2017 07:09 AM - nobu (Nobuyoshi Nakada)

- Status changed from Open to Closed

Applied in changeset trunk|r60979.

string.c: fix rb_external_str_new_with_enc

string.c (rb_external_str_new_with_enc): do not search non-ascii

by NULL pointer.  [ruby-core:84055] [Bug #14150]

Files

extconf.rb 49 Bytes 12/02/2017 kubo (Takehiro Kubo)

str_new_funcs.c 809 Bytes 12/02/2017 kubo (Takehiro Kubo)
